using MediatR;
using Sledgemapper.Api.Infrastructure.Data;

using System.Text.Json;
using System.Threading;
using System.Threading.Tasks;
using System.Linq;

namespace Sledgemapper.Api.Commands
{
    public class NewSnapshotCommandHandler : IRequestHandler<NewSnapshotCommand, bool>
    {
        private readonly SledgemapperDbContext _dbcontext;
        private readonly IMediator _mediator;

        public NewSnapshotCommandHandler(IMediator mediator, SledgemapperDbContext dbcontext) { _dbcontext = dbcontext; _mediator = mediator; }

        public async Task<bool> Handle(NewSnapshotCommand notification, CancellationToken cancellationToken)
        {
          
            var session = _dbcontext.Sessions.First(m => m.SessionName == notification.SessionName);

           var newSnapshot = new Sledgemapper.Api.Models.Snapshot{
    SessionId=session.SessionId,
    Timestamp=notification.Timestamp,
    Object = JsonSerializer.Serialize<Sledgemapper.Shared.Entities.Session>(notification.Session)

};
await _dbcontext.Snapshots.AddAsync(newSnapshot);
            await _dbcontext.SaveChangesAsync();
           
            return true;
        }


    }
}
